package ns.gui;

import javax.swing.*;
import javax.swing.text.DefaultCaret;
import java.awt.event.KeyAdapter;
import java.awt.event.MouseAdapter;
import java.awt.*;


/**
 * customizes a JTextArea in such a way that it is jsut a panel with text on it (i.e. no clicking, no selecting etc)
 */
public class TextDisplay extends JPanel{
    private JTextArea messageArea;
    public TextDisplay(Font messageFont, final Color messageBackground, final Color messageForeground) {
       this(new JTextArea());
       this.messageArea.setFont(messageFont);
       this.messageArea.setForeground(messageForeground);//Color.LIGHT_GRAY);
       this.messageArea.setBackground(messageBackground); //50% black
       this.messageArea.setWrapStyleWord(true);
       this.messageArea.setLineWrap(true);
    }

    public TextDisplay(JTextArea messageArea) {
        this.messageArea = messageArea;
        setOpaque(false);
        OverlayLayout ol = new OverlayLayout(this);
        setLayout(ol);
        JPanel glassPanel = new JPanel();
        glassPanel.setOpaque(false);
        glassPanel.addKeyListener(new KeyAdapter() {});
        glassPanel.addMouseListener(new MouseAdapter(){});
        glassPanel.setFocusable(false);
        add(glassPanel);
        add(messageArea);
        messageArea.setEditable(false);
           DefaultCaret dc = new DefaultCaret(){
            public Dimension getSize() {
                return new Dimension((int)getWidth(),(int)getHeight());
            }
            public double getWidth() {
                return 0;
            }
            public double getHeight() {
                return 0;
            }
        };
        messageArea.setCaret(dc);
        messageArea.setHighlighter(null);
        messageArea.setFocusable(false);
        messageArea.setEditable(false);
    }

    public JTextArea getMessageArea() {
        return messageArea;
    }


}
