package uk.co.hcsoftware.commander;

import java.util.logging.Logger;
import java.text.NumberFormat;
import java.text.DecimalFormat;
import java.math.BigDecimal;


/**
 * Title: NumberFormatter
 * Copyright:    Copyright (c) 28-Oct-2005
 *
 * @author spurlinn
 */
public class NumberFormatter {
    public static final Logger log = Logger.getLogger(NumberFormatter.class.getName());
    private final NumberFormat nf = new DecimalFormat("##########.#");
    private float round(long bytes,float cuttoff) {
        BigDecimal bd = new BigDecimal(bytes/cuttoff);
        bd=bd.setScale(1,BigDecimal.ROUND_HALF_UP);
        return bd.floatValue();
    }
    public String formatBytes(long bytes){
        if(bytes<1000){//0-1k
            return String.valueOf(bytes);
        }
        else if(bytes<1000000){ //1k-1M
            float f= round(bytes,1000f);
            return nf.format(f)+"k";
        }
        else if(bytes<(1000*1000*1000)){ //1M-1G
            float f= round(bytes,1000000f);
            return nf.format(f)+"M";
        }
        else{ //1G+
            float f= round(bytes,1000000000f);
            return nf.format(f)+"G";
        }
    }
}
