package uk.co.hcsoftware.commander.bookmarks;


import uk.co.hcsoftware.commander.Url;
import uk.co.hcsoftware.commander.Url;

import java.util.logging.Logger;

/**
 * a bookmark can have 1 or 2 urls that correspond to the 2 panes in the currently visible frame
 *
 */
public class Bookmark implements Cloneable{
    private static final Logger log = Logger.getLogger(Bookmark.class.getName());

    private Url f1,f2;
    private String name;

    public Bookmark() {
    }

    public Bookmark(String name) {
        this.name = name;
    }

    public boolean isDirectory(){
        return f1==null && f2==null;
    }

    public Url getF1() {
        return f1;
    }

    public Object clone() throws CloneNotSupportedException {
        return super.clone();
    }

    public Url getF2() {
        return f2;
    }
    public boolean isSuperBookmark(){
        return f2!=null;
    }

    public void setF2(Url f2) {
        this.f2 = f2;
    }

    public String getName() {
        return name;
    }

    public void setF1(Url f) {
        this.f1 = f;
    }

    public void setName(String name) {
        this.name = name;
    }

    public String toString() {
        return "f1="+f1+" f2="+f2+" name="+name;
    }
    //javabean (for persistence) representing a bookmark to some directory
    public uk.co.hcsoftware.commander.Bookmark.BookmarkBean getBean(){
        return new uk.co.hcsoftware.commander.Bookmark.BookmarkBean(toString(f1),toString(f2),name);
    }
    private String toString(Url f1){
        if(f1==null) return null;
        return f1.stringify();//f1.toExternalForm();
    }

    public static Bookmark createBookmark(Url f,Url f2, String name) {
        final Bookmark bookmark = new Bookmark();
        bookmark.f1=f;
        bookmark.f2 = f2;
        bookmark.name=name;
        return bookmark;
    }

}
