package uk.co.hcsoftware.commander.gui;

import java.awt.*;
import java.io.IOException;
import java.net.URL;
import java.util.logging.Level;
import java.util.logging.Logger;

public class AboutDialog extends HtmlDialog {
    private static final Logger log = Logger.getLogger(AboutDialog.class.getName());

    public AboutDialog(Frame owner, String title) throws HeadlessException {
        super(owner,title, false);
        final String text = "Java version: "+System.getProperty("java.version")
                +" OS: "+System.getProperty("os.name");
        log.fine("text="+text);

        setStatusText(text);
        try {
            URL url = AboutDialog.class.getClassLoader().getResource("about.html");
            log.fine("url="+url);
            loadHtml(url);
        } catch (IOException e) {
            log.log(Level.WARNING,"couldn't load about.html",e);
//            JTextArea jta = new JTextArea(defaultText);
//            jta.setEditable(false);
//            mainPan.add(jta);
        }
        setSize(450,400);
        setLocationRelativeTo(owner);
    }

}
