package uk.co.hcsoftware.commander.gui;

import javax.swing.*;
import java.awt.*;
import java.awt.event.MouseAdapter;
import java.awt.event.KeyAdapter;
import java.awt.event.KeyEvent;
import java.util.logging.Logger;


public class BlockGlassPane extends JComponent{
    private static final Logger log = Logger.getLogger(BlockGlassPane.class.getName());
    private final Color glassColor = new Color(0,0,0,255/2);
    private Font font = new Font("Dialog",Font.BOLD,20);
    public BlockGlassPane() {
        addMouseListener(new MouseAdapter() {});
        addKeyListener(new KeyAdapter(){     //todo: this doesn't catch keyevents in the frame's inputmap..
            public void keyPressed(KeyEvent e) {
                log.fine("keypressed="+e);
                e.consume();
            }

            public void keyTyped(KeyEvent e) {
                log.fine("keyTyped="+e);
                e.consume();
            }

            public void keyReleased(KeyEvent e) {
                log.fine("keyReleased="+e);
                e.consume();
            }
        });
    }

    private String text=null;
    public void setText(String text) {
       this.text=text;
        repaint();
    }
    protected void paintComponent(Graphics g) {
        g.setColor(glassColor);
        g.fillRect(getX(),getY(),getWidth(),getHeight());

       if(text!=null){
           g.setFont(font);
           g.setColor(Color.white);
           g.drawString(text,findStart(getX(),getWidth(),200)
                   ,findStart(getY(),getHeight(),20));
       }
    }
    private int findMid(int xy, int hw){
        return (hw-xy)/2;
    }
    private int findStart(int xy, int hw, int compW){
        int mid = findMid(xy,hw);
        int start = mid-(compW/2);
        return start;
    }
}
