package uk.co.hcsoftware.commander.gui;

import java.awt.*;
import java.util.ArrayList;
import java.util.LinkedList;
import java.util.List;
import java.util.ListIterator;
import java.util.logging.Logger;


/**
 * Title: CommanderFocus
 * Copyright:    Copyright (c) 18-Nov-2005
 *
 * @author spurlinn
 */
public class CommanderFocus {
    public static final Logger log = Logger.getLogger(CommanderFocus.class.getName());
    private Component focusOwner;
    public void giveFocus(Component o){
        Component prevOwner=focusOwner;
        focusOwner=o;
        previousFocusHolders.add(focusOwner);
        if(previousFocusHolders.size()>=5){
            previousFocusHolders.removeFirst();
        }
        fireFocusGained(prevOwner,o);
    }
    private LinkedList<Object> previousFocusHolders=new LinkedList<Object>();
    public boolean hasFocus(Component o){
        if(focusOwner==null) return false;
        return focusOwner.equals(o);
    }
    private void fireFocusGained(Component lostFocus, Component gainedFocus){
         for(CommanderFocusListener cfl:new ArrayList<CommanderFocusListener>(listeners)){
             cfl.focusChanged(lostFocus, gainedFocus);
         }
    }

    /**
     *
     * @param candidates
     * @return the member of the candidates list that most recently held the focus (or null if none did in living memory)
     */
    public Object getMostRecentFocusHolder(Object... candidates) {
        for (ListIterator li = previousFocusHolders.listIterator(previousFocusHolders.size()); li.hasPrevious();) {
            Object o=li.previous();
            for(Object c:candidates){
                if(o.equals(c)) return o;
            }
        }
        return null;
    }

    public static interface CommanderFocusListener{
        public void focusChanged(Component lostFocus, Component gainedFocus);
    }
    private List<CommanderFocusListener> listeners = new ArrayList<CommanderFocusListener>();
    public void addListener(CommanderFocusListener cfl){
        listeners.add(cfl);
    }
}
