package uk.co.hcsoftware.commander.gui;

import javax.swing.*;
import javax.swing.border.BevelBorder;
import java.awt.*;
import java.awt.event.ActionEvent;
import java.awt.event.KeyEvent;
import java.awt.event.WindowEvent;
import java.awt.event.WindowFocusListener;
import java.io.IOException;
import java.net.URL;
import java.util.logging.Logger;


public class HtmlDialog extends JDialog {
    public static final Logger log = Logger.getLogger(HtmlDialog.class.getName());
    protected JEditorPane jep;
    protected JLabel jl;

    public HtmlDialog(Frame owner, String title, boolean isTransient) throws HeadlessException {
        super(owner, title, false);
        jep = new JEditorPane("text/html","");
        jl = new JLabel();
        super.setDefaultCloseOperation(JDialog.HIDE_ON_CLOSE);
        if (isTransient) {
            super.setUndecorated(true);
            addWindowFocusListener(new WindowFocusListener() {
                public void windowGainedFocus(WindowEvent e) { }
                public void windowLostFocus(WindowEvent e) {
                    log.info("windowLostFocus2");
                    dispose();
                }
            });
        }

        JPanel mainPan = new JPanel(new BorderLayout());
        mainPan.getInputMap().put(KeyStroke.getKeyStroke(KeyEvent.VK_ESCAPE,0),"dispose");
        mainPan.getActionMap().put("dispose",new AbstractAction() {
            public void actionPerformed(ActionEvent e) {
                dispose();
            }
        });
        mainPan.setBorder(BorderFactory.createEmptyBorder(5,5,5,5));
        getContentPane().add(mainPan);
        mainPan.setBorder(BorderFactory.createBevelBorder(BevelBorder.RAISED));

        mainPan.add(jl,BorderLayout.SOUTH);
        jep.setEditable(false);
        mainPan.add(new JScrollPane(jep));

        setSize(450,300);
        setLocationRelativeTo(owner);


    }

    protected void setStatusText(final String text) {
        jl.setText(text);
    }

    public void loadHtml(URL url) throws IOException {
        jep.setPage(url);
    }

    public void loadHtml(String html) {
        jep.setText(html);
    }
}
