/* ----------------------------------------------------------------
 * FILENAME    : ${NAME}
 * DESCRIPTION : 
 *               
 *
 * PROJECT     : stockconfig
 *
 * PROGRAMMER  : spurln
 *
 * COPYRIGHT   : Copyright (c) 2004 - The Goldman, Sachs Group, Inc.
 *                               All rights reserved
 *
 * Source      : $Source: 
 * Revision    : $Revision: 
 * Last Changed: $Date: 
 * ---------------------------------------------------------------- */
package uk.co.hcsoftware.commander.gui;

import javax.swing.*;
import java.util.logging.Level;
import java.util.logging.Logger;
import java.awt.*;
import java.net.URL;

public class ImageProvider {
    private static Logger log = Logger.getLogger(ImageProvider.class.getName());

    private static ImageProvider ourInstance = new ImageProvider();

    public static ImageProvider getInstance() {
        return ourInstance;
    }

    private ImageProvider() {
    }
     public ImageIcon getIcon(String name){
        try {

            final URL systemResource = //ClassLoader.getSystemResource(name);
            ImageProvider.class.getClassLoader().getResource(name);
            return new ImageIcon(systemResource);
        } catch (Exception e) {
            log.log(Level.WARNING,"couldn't load image name="+name,e);
            return null;
        }
    }
    public Image getImage(String name){
        ImageIcon ii = getIcon(name);
        if(ii==null) return null;
        return ii.getImage();
    }
}
