package uk.co.hcsoftware.commander.prefs;

import uk.co.hcsoftware.commander.gui.CommanderFrame;

import javax.swing.*;
import java.awt.*;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;


public class PrefsDialog extends JDialog{
    public PrefsDialog(CommanderFrame cf) throws HeadlessException {
        super(cf,"Preferences",true);
        JPanel jp = new JPanel(new BorderLayout(5,5));
        getContentPane().add(jp);
        jp.setBorder(BorderFactory.createEmptyBorder(6,6,6,6));
        JTabbedPane jtp = new JTabbedPane();
        jp.add(jtp);
        final PrefsTab[] tabs={new ColorPanel()};
        for(PrefsTab pt:tabs){
            jtp.addTab(pt.getName(),pt.getComponent());
        }
        JPanel bPanel = new JPanel(new FlowLayout(FlowLayout.RIGHT));
        final JButton ok=new JButton("OK"),cancel=new JButton("Cancel"),apply=new JButton("Apply");
        ActionListener al = new ActionListener() {
            private void apply() {
                for(PrefsTab pt:tabs){
                    pt.apply();
                }
            }
            public void actionPerformed(ActionEvent e) {
                Object o = e.getSource();
                if(o==cancel){
                    dispose();
                }
                else if(o==apply){
                    apply();
                }
                else{
                    apply();
                    dispose();
                }
            }
        };
        for(JButton jb:new JButton[]{cancel,apply,ok}){
            jb.addActionListener(al);
            bPanel.add(jb);
        }
        jp.add(bPanel,BorderLayout.SOUTH);
        pack();
        setSize(400,600);
    }



}
