package uk.co.hcsoftware.commander.tree;

import java.util.Map;
import java.util.HashMap;


/**
 * Title: DefaultColumnSpec
 * Copyright:    Copyright (c) 08-Nov-2005
 *
 * @author spurlinn
 */
public class DefaultColumnSpec implements ColumnSpec{
    private final int defaultWidth;
    private final CtreeModel model;

    public int getNameColumn() {
        return 0;
    }

    public int getDirColumn() {
        return 1;
    }

    public DefaultColumnSpec(CtreeModel model) {
        this(75,model);
    }
    public DefaultColumnSpec(int defaultWidth, CtreeModel model) {
        this.defaultWidth = defaultWidth;
        this.model = model;
    }
    public int getDefaultWidth(int attributeIndex) {
        if(widths.containsKey(attributeIndex)) return widths.get(attributeIndex);
        return defaultWidth;
    }
    private Map<Integer,Integer> widths = new HashMap<Integer, Integer>(0);
    public void setWidth(int attributeIndex,int width){
        widths.put(attributeIndex,width);
    }
    public String getAttributeName(int index) {
        return model.getAttributeName(index);
    }
    private CommanderCellRenderer renderer = new DefaultCommanderCellRenderer();

    public void setDefaultRenderer(CommanderCellRenderer renderer) {
        this.renderer = renderer;
    }
    private Map<Integer,CommanderCellRenderer> renderers = new HashMap<Integer, CommanderCellRenderer>(0);
    public void setRenderer(int attributeIndex, CommanderCellRenderer renderer) {
        if(renderer ==null) renderers.remove(attributeIndex);
        else renderers.put(attributeIndex,renderer);
    }

    public CommanderCellRenderer getCellRenderer(int attributeIndex) {
        if(renderers.containsKey(attributeIndex)) return renderers.get(attributeIndex);
        return renderer;
//        final Font plainFont = new Font("lucida sans",Font.PLAIN,12);
//        final Font boldFont = new Font("lucida sans",Font.BOLD,12);


//        tableCellRenderer =
//                new DefaultTableCellRenderer(){
//                    public Component getTableCellRendererComponent(JTable table, Object value, boolean isSelected, boolean hasFocus, int row, int column) {
//                        FileRef f = getFileRef(row);
//                        setFont(f.isDirectory()?boldFont:plainFont);
//                        final String vs;
//                        if (isSelected) {
//                            super.setForeground(selectionForeColor);//table.getSelectionForeground());
//                            super.setBackground(selectionColor);
//                            setBorder(rowSelBorder);
//                        }
//                        else if (f.isMarked()){
//                            super.setForeground(selectionForeColor);//table.getSelectionForeground());
//                            super.setBackground(markColor);
//                            setBorder(markSelBorder);
//                        }
//                        else {
//                            super.setForeground(table.getForeground());
//                            super.setBackground(table.getBackground());
//                            setBorder(noSelBorder);
//                        }
//
//                        // setBorder(null);
//                        return this;
//                    }
//                }
//
//        return tableCellRenderer;
    }

//    public void setTableCellRenderer(DefaultTableCellRenderer tableCellRenderer) {
//        this.tableCellRenderer = tableCellRenderer;
//    }
}
