package uk.co.hcsoftware.commander.treeplugin;

import uk.co.hcsoftware.commander.CannotOpenUrlException;
import uk.co.hcsoftware.commander.Commandable;
import uk.co.hcsoftware.commander.Url;
import uk.co.hcsoftware.commander.gui.HostFrame;
import uk.co.hcsoftware.commander.tree.CommanderTree;

import java.awt.datatransfer.Transferable;

/**
 * Title: TreePlugin
 * Copyright:    Copyright (c) 22-Nov-2005
 *
 * @author spurlinn
 *
 */
public interface TreePlugin extends Commandable{

    CommanderTree createTree();

    void install(HostFrame o);
    void uninstall(HostFrame hf);

    void openUrl(Url s) throws CannotOpenUrlException;
    Url getUrl(Object node);
    /**
     *
     * @param t
     * @throws NotSupportedException
     * @throws CannotSaveException
     */
    void save(Transferable t) throws NotSupportedException, CannotSaveException;


}
