package uk.co.hcsoftware.commander.treeplugin.file;

import java.util.ArrayList;
import java.util.Collections;
import java.util.List;
import java.util.logging.Logger;
import java.io.File;

public class FileEventManager {
    private static final Logger log = Logger.getLogger(FileEventManager.class.getName());
    private static FileEventManager ourInstance = new FileEventManager();

    public static FileEventManager getInstance() {
        return ourInstance;
    }

    private FileEventManager() {
    }
     //public static final class File
    public interface FileEventListener{
        void filesChanged(FilesChangedEvent fe);
     }

    private List<FileEventListener> l = Collections.synchronizedList(new ArrayList<FileEventListener>());
    public void addListener(FileEventListener fel){
        l.add(fel);
    }
    public void removeListener(FileEventListener fel){
        l.remove(fel);
    }
    public void fireEvent(final FilesChangedEvent fe){
        log.fine("fireEvent fe="+fe);
        for(FileEventListener fel: new ArrayList<FileEventListener>(l)){
            fel.filesChanged(fe);
        }
    }
    public void fireEvent(List<File> deleted, List<File> added, List<File> changed){
        fireEvent(new FilesChangedEvent(deleted,added,changed));
    }
}
