package uk.co.hcsoftware.commander.treeplugin.file;

import java.util.ArrayList;
import java.util.Collections;
import java.util.List;
import java.io.File;

public final class FilesChangedEvent {
    private final List<File> deleted,added,changed;

    public FilesChangedEvent(List<File> deleted, List<File> added, List<File> changed) {
        List<File> empty = Collections.emptyList();
        this.deleted = deleted==null?empty:deleted;
        this.added = added==null?empty:added;
        this.changed = changed==null?empty:changed;
    }

    public List<File> getDeleted() {
        return deleted;
    }

    public List<File> getAdded() {
        return added;
    }

    public List<File> getChanged() {
        return changed;
    }
    private List<File> getSubList(List<File> l, File parent){
        List<File> subList = new ArrayList<File>();
        for(File f:l) if(parent.equals(f.getParentFile())) subList.add(f);
        return subList;
    }
    public List<File> getDeleted(File parent) {
        return getSubList(deleted,parent);
    }

    public List<File> getAdded(File parent) {
        return getSubList(added,parent);
    }

    public List<File> getChanged(File parent) {
        return getSubList(changed,parent);
    }

    public String toString() {
        return "added="+added+" deleted="+deleted+" changed="+changed;
    }


}
